#include "HAHead.hlsl"

#define BLENDDIFFUSE0TEXTURE "gUMetal.png"
#define BLENDDIFFUSE0TEXTURE_X 256
#define BLENDDIFFUSE0TEXTURE_Y 256
#define BLENDSPECULAR0TEXTURE "Metal.png"
#define BLENDSPECULAR0TEXTURE_X 256
#define BLENDSPECULAR0TEXTURE_Y 256
//#define BLENDADDSPHERE0TEXTURE
#define BLENDADDSPHERE0TEXTURE_X 256
#define BLENDADDSPHERE0TEXTURE_Y 256
//#define BLENDEDGE0TEXTURE
#define BLENDEDGE0TEXTURE_X 256
#define BLENDEDGE0TEXTURE_Y 256
//#define USE_LOCALSHADOW
#define USE_EXCELLENTSHADOW
#define SHADE_TOONLESS
//#define AMBIENT_AS_BASE
//#define AMBIENT_TOON_AS_BASE
//#define HANDLE_EDGE
//#define USE_NORMALMAP
#ifdef BLENDDIFFUSE0TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendDiffuse0Texture, BlendDiffuse0TextureSampler, BLENDDIFFUSE0TEXTURE, Clamp, Clamp)
#endif
#ifdef BLENDSPECULAR0TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendSpecular0Texture, BlendSpecular0TextureSampler, BLENDSPECULAR0TEXTURE, Clamp, Clamp)
#endif

float EdgeWidthRate
<
	string UIName = "GbW";
	string UIWidget = "Numeric";
	float UIMin = 0;
	float UIMax = 2;
> = 0.6;

float NormalMapResolution
<
string UIName = "@}bv𑜓x";
string UIWidget = "Numeric";
float UIMin = 0;
float UIMax = 10;
> = 1;

float3 BlendDiffuse0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE0TEXTURE
	float4 value = tex2D(BlendDiffuse0TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r += value.r * value.a;
	target.g += value.g * value.a;
	target.b += value.b * value.a;
	#endif
	
	return target;
}

float3 BlendDiffuse(float3 color, BlendParameters parameters)
{
	color = BlendDiffuse0(color, parameters);

	return color;
}

float3 BlendSpecular0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDSPECULAR0TEXTURE
	float4 value = tex2D(BlendSpecular0TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r += value.r * value.a;
	target.g += value.g * value.a;
	target.b += value.b * value.a;
	#endif
	
	return target;
}

float3 BlendSpecular(float3 color, BlendParameters parameters)
{
	color = BlendSpecular0(color, parameters);

	return color;
}

float3 BlendAddSphere0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDADDSPHERE0TEXTURE
	float3 targetHsv = GetHsvFromRgb(target);
	float4 value = float4(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal, parameters.ExtendedLightNormal, 1);
	
	targetHsv.x = lerp(targetHsv.x, targetHsv.x * value.r, value.a);
	targetHsv.y = lerp(targetHsv.y, targetHsv.y * value.g, value.a);
	targetHsv.z = lerp(targetHsv.z, targetHsv.z * value.b, value.a);
	target = GetRgbFromHsv(targetHsv);
	#endif
	
	return target;
}

float3 BlendAddSphere(float3 color, BlendParameters parameters)
{
	color = BlendAddSphere0(color, parameters);

	return color;
}

float3 BlendEdge0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDEDGE0TEXTURE
	float4 value = float4(0, 0, 0, 1);
	
	target.r = lerp(target.r, value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendEdge(float3 color, BlendParameters parameters)
{
	color = BlendEdge0(color, parameters);

	return color;
}

#include "HACore.hlsl"

// HAGenerator Document
// HA2 QA5FZmZlY3REb2N1bWVudAQVQ29weUNvcmVUb0Rlc3RpbmF0aW9umARUcnVlBAlFZGdlV2lkdGiY
// HA2 AzAuNgQRRml4TGlnaHREaXJlY3Rpb26YBUZhbHNlBAxGaXhTcGhlcmVNYXCYBUZhbHNlBApIYW5k
// HA2 bGVFZGdlmAVGYWxzZQQTTm9ybWFsTWFwUmVzb2x1dGlvboIEEE5vcm1hbE1hcFRleHR1cmWoBBBT
// HA2 ZXRBbWJpZW50QXNCYXNlmAVGYWxzZQQYU2V0QW1iaWVudEFzQmFzZVdpdGhUb29umAVGYWxzZQQN
// HA2 U2hhZGVUb29ubGVzc5gEVHJ1ZQQSVXNlRXhjZWxsZW50U2hhZG93mARUcnVlBA5Vc2VMb2NhbFNo
// HA2 YWRvd5gFRmFsc2UEDFVzZU5vcm1hbE1hcJgFRmFsc2UIOWNsci1uYW1lc3BhY2U6TGluZWFyc3Rh
// HA2 ci5IQUdlbmVyYXRvcjthc3NlbWJseT1IQUdlbmVyYXRvcgkBeCxodHRwOi8vc2NoZW1hcy5taWNy
// HA2 b3NvZnQuY29tL3dpbmZ4LzIwMDYveGFtbEAfRWZmZWN0RG9jdW1lbnQuQWRkU3BoZXJlRW50cmll
// HA2 c0AKQmxlbmRFbnRyeQQJSXNFbmFibGVkmAVGYWxzZQQKSXNTcGVjdWxhcpgEVHJ1ZQQKUGFyYW1l
// HA2 dGVyWJgTRXh0ZW5kZWRMaWdodE5vcm1hbAQKUGFyYW1ldGVyWZgTRXh0ZW5kZWRMaWdodE5vcm1h
// HA2 bEASQmxlbmRFbnRyeS5BY3Rpb25zdQVBcnJheQQEVHlwZZgLQmxlbmRBY3Rpb25AC0JsZW5kQWN0
// HA2 aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgDUmVkBA1UYXJnZXRDaGFubmVs
// HA2 mANIdWUBQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBUdy
// HA2 ZWVuBA1UYXJnZXRDaGFubmVsmApTYXR1cmF0aW9uAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRp
// HA2 cGx5BBBQYXJhbWV0ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVsmAVWYWx1ZQEBAUASQmxl
// HA2 bmRFbnRyeS5UZXh0dXJlQAdUZXh0dXJlBAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWoBARLaW5k
// HA2 mANSZ2IEDFZhcmlhYmxlTmFtZZgWQmxlbmRBZGRTcGhlcmUwVGV4dHVyZQEBAQFAHUVmZmVjdERv
// HA2 Y3VtZW50LkRpZmZ1c2VFbnRyaWVzQApCbGVuZEVudHJ5BAlJc0VuYWJsZWSYBFRydWUECklzU3Bl
// HA2 Y3VsYXKYBUZhbHNlBApQYXJhbWV0ZXJYmBNFeHRlbmRlZExpZ2h0Tm9ybWFsBApQYXJhbWV0ZXJZ
// HA2 mBNFeHRlbmRlZExpZ2h0Tm9ybWFsQBJCbGVuZEVudHJ5LkFjdGlvbnN1BUFycmF5BARUeXBlmAtC
// HA2 bGVuZEFjdGlvbkALQmxlbmRBY3Rpb24EBEtpbmSYA0FkZAQQUGFyYW1ldGVyQ2hhbm5lbJgDUmVk
// HA2 BA1UYXJnZXRDaGFubmVsmANSZWQBQAtCbGVuZEFjdGlvbgQES2luZJgDQWRkBBBQYXJhbWV0ZXJD
// HA2 aGFubmVsmAVHcmVlbgQNVGFyZ2V0Q2hhbm5lbJgFR3JlZW4BQAtCbGVuZEFjdGlvbgQES2luZJgD
// HA2 QWRkBBBQYXJhbWV0ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVsmARCbHVlAQEBQBJCbGVu
// HA2 ZEVudHJ5LlRleHR1cmVAB1RleHR1cmUEBE5hbWWYCHt4Ok51bGx9BAhGaWxlTmFtZZgP5ouh5pWj
// HA2 TWV0YWwucG5nBARLaW5kmANSZ2IEDFZhcmlhYmxlTmFtZZgUQmxlbmREaWZmdXNlMFRleHR1cmUB
// HA2 AQEBQBpFZmZlY3REb2N1bWVudC5FZGdlRW50cmllc0AKQmxlbmRFbnRyeQQJSXNFbmFibGVkmAVG
// HA2 YWxzZQQKSXNTcGVjdWxhcpgFRmFsc2UEClBhcmFtZXRlcliYBE5vbmUEClBhcmFtZXRlclmYBE5v
// HA2 bmVAEkJsZW5kRW50cnkuQWN0aW9uc3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtCbGVuZEFj
// HA2 dGlvbgQES2luZJgHUmVwbGFjZQQQUGFyYW1ldGVyQ2hhbm5lbJgDUmVkBA1UYXJnZXRDaGFubmVs
// HA2 mANSZWQBQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBUdy
// HA2 ZWVuBA1UYXJnZXRDaGFubmVsmAVHcmVlbgFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQ
// HA2 UGFyYW1ldGVyQ2hhbm5lbJgEQmx1ZQQNVGFyZ2V0Q2hhbm5lbJgEQmx1ZQEBAUASQmxlbmRFbnRy
// HA2 eS5UZXh0dXJlQAdUZXh0dXJlBAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWoBARLaW5kmANSZ2IE
// HA2 DFZhcmlhYmxlTmFtZZgRQmxlbmRFZGdlMFRleHR1cmUBAQEBQB5FZmZlY3REb2N1bWVudC5TcGVj
// HA2 dWxhckVudHJpZXNACkJsZW5kRW50cnkECUlzRW5hYmxlZJgEVHJ1ZQQKSXNTcGVjdWxhcpgEVHJ1
// HA2 ZQQKUGFyYW1ldGVyWJgTRXh0ZW5kZWRMaWdodE5vcm1hbAQKUGFyYW1ldGVyWZgTRXh0ZW5kZWRM
// HA2 aWdodE5vcm1hbEASQmxlbmRFbnRyeS5BY3Rpb25zdQVBcnJheQQEVHlwZZgLQmxlbmRBY3Rpb25A
// HA2 C0JsZW5kQWN0aW9uBARLaW5kmANBZGQEEFBhcmFtZXRlckNoYW5uZWyYA1JlZAQNVGFyZ2V0Q2hh
// HA2 bm5lbJgDUmVkAUALQmxlbmRBY3Rpb24EBEtpbmSYA0FkZAQQUGFyYW1ldGVyQ2hhbm5lbJgFR3Jl
// HA2 ZW4EDVRhcmdldENoYW5uZWyYBUdyZWVuAUALQmxlbmRBY3Rpb24EBEtpbmSYA0FkZAQQUGFyYW1l
// HA2 dGVyQ2hhbm5lbJgEQmx1ZQQNVGFyZ2V0Q2hhbm5lbJgEQmx1ZQEBAUASQmxlbmRFbnRyeS5UZXh0
// HA2 dXJlQAdUZXh0dXJlBAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWYD+mPoemdok1ldGFsLnBuZwQE
// HA2 S2luZJgDUmdiBAxWYXJpYWJsZU5hbWWYFUJsZW5kU3BlY3VsYXIwVGV4dHVyZQEBAQEB