#include "HAHead.hlsl"

#define BLENDDIFFUSE0TEXTURE "gUO[.png"
#define BLENDDIFFUSE0TEXTURE_X 256
#define BLENDDIFFUSE0TEXTURE_Y 256
#define BLENDSPECULAR0TEXTURE "ʃO[.png"
#define BLENDSPECULAR0TEXTURE_X 256
#define BLENDSPECULAR0TEXTURE_Y 256
//#define BLENDADDSPHERE0TEXTURE
#define BLENDADDSPHERE0TEXTURE_X 256
#define BLENDADDSPHERE0TEXTURE_Y 256
//#define BLENDEDGE0TEXTURE
#define BLENDEDGE0TEXTURE_X 256
#define BLENDEDGE0TEXTURE_Y 256
//#define USE_LOCALSHADOW
#define USE_EXCELLENTSHADOW
#define SHADE_TOONLESS
//#define AMBIENT_AS_BASE
//#define AMBIENT_TOON_AS_BASE
//#define HANDLE_EDGE
//#define USE_NORMALMAP
#ifdef BLENDDIFFUSE0TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendDiffuse0Texture, BlendDiffuse0TextureSampler, BLENDDIFFUSE0TEXTURE, Clamp, Clamp)
#endif
#ifdef BLENDSPECULAR0TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendSpecular0Texture, BlendSpecular0TextureSampler, BLENDSPECULAR0TEXTURE, Clamp, Clamp)
#endif

float EdgeWidthRate
<
	string UIName = "GbW";
	string UIWidget = "Numeric";
	float UIMin = 0;
	float UIMax = 2;
> = 0.6;

float NormalMapResolution
<
string UIName = "@}bv𑜓x";
string UIWidget = "Numeric";
float UIMin = 0;
float UIMax = 10;
> = 1;

float3 BlendDiffuse0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE0TEXTURE
	float4 value = tex2D(BlendDiffuse0TextureSampler, float2(parameters.LightNormal, parameters.LightNormal));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse(float3 color, BlendParameters parameters)
{
	color = BlendDiffuse0(color, parameters);

	return color;
}

float3 BlendSpecular0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDSPECULAR0TEXTURE
	float4 value = tex2D(BlendSpecular0TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r += value.r * value.a;
	target.g += value.g * value.a;
	target.b += value.b * value.a;
	#endif
	
	return target;
}

float3 BlendSpecular(float3 color, BlendParameters parameters)
{
	color = BlendSpecular0(color, parameters);

	return color;
}

float3 BlendAddSphere0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDADDSPHERE0TEXTURE
	float4 value = float4(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal, parameters.ExtendedLightNormal, 1);
	
	target.r += value.r * value.a;
	target.g += value.g * value.a;
	target.b += value.b * value.a;
	#endif
	
	return target;
}

float3 BlendAddSphere(float3 color, BlendParameters parameters)
{
	color = BlendAddSphere0(color, parameters);

	return color;
}

float3 BlendEdge0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDEDGE0TEXTURE
	float4 value = float4(0, 0, 0, 1);
	
	target.r = lerp(target.r, value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendEdge(float3 color, BlendParameters parameters)
{
	color = BlendEdge0(color, parameters);

	return color;
}

#include "HACore.hlsl"

// HAGenerator Document
// HA2 QA5FZmZlY3REb2N1bWVudAQVQ29weUNvcmVUb0Rlc3RpbmF0aW9umARUcnVlBAlFZGdlV2lkdGiY
// HA2 AzAuNgQRRml4TGlnaHREaXJlY3Rpb26YBUZhbHNlBAxGaXhTcGhlcmVNYXCYBUZhbHNlBApIYW5k
// HA2 bGVFZGdlmAVGYWxzZQQTTm9ybWFsTWFwUmVzb2x1dGlvboIEEE5vcm1hbE1hcFRleHR1cmWoBBBT
// HA2 ZXRBbWJpZW50QXNCYXNlmAVGYWxzZQQYU2V0QW1iaWVudEFzQmFzZVdpdGhUb29umAVGYWxzZQQN
// HA2 U2hhZGVUb29ubGVzc5gEVHJ1ZQQSVXNlRXhjZWxsZW50U2hhZG93mARUcnVlBA5Vc2VMb2NhbFNo
// HA2 YWRvd5gFRmFsc2UEDFVzZU5vcm1hbE1hcJgFRmFsc2UIOWNsci1uYW1lc3BhY2U6TGluZWFyc3Rh
// HA2 ci5IQUdlbmVyYXRvcjthc3NlbWJseT1IQUdlbmVyYXRvcgkBeCxodHRwOi8vc2NoZW1hcy5taWNy
// HA2 b3NvZnQuY29tL3dpbmZ4LzIwMDYveGFtbEAfRWZmZWN0RG9jdW1lbnQuQWRkU3BoZXJlRW50cmll
// HA2 c0AKQmxlbmRFbnRyeQQJSXNFbmFibGVkmAVGYWxzZQQKSXNTcGVjdWxhcpgEVHJ1ZQQKUGFyYW1l
// HA2 dGVyWJgTRXh0ZW5kZWRMaWdodE5vcm1hbAQKUGFyYW1ldGVyWZgTRXh0ZW5kZWRMaWdodE5vcm1h
// HA2 bEASQmxlbmRFbnRyeS5BY3Rpb25zdQVBcnJheQQEVHlwZZgLQmxlbmRBY3Rpb25AC0JsZW5kQWN0
// HA2 aW9uBARLaW5kmANBZGQEEFBhcmFtZXRlckNoYW5uZWyYA1JlZAQNVGFyZ2V0Q2hhbm5lbJgDUmVk
// HA2 AUALQmxlbmRBY3Rpb24EBEtpbmSYA0FkZAQQUGFyYW1ldGVyQ2hhbm5lbJgFR3JlZW4EDVRhcmdl
// HA2 dENoYW5uZWyYBUdyZWVuAUALQmxlbmRBY3Rpb24EBEtpbmSYA0FkZAQQUGFyYW1ldGVyQ2hhbm5l
// HA2 bJgEQmx1ZQQNVGFyZ2V0Q2hhbm5lbJgEQmx1ZQEBAUASQmxlbmRFbnRyeS5UZXh0dXJlQAdUZXh0
// HA2 dXJlBAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWoBARLaW5kmANSZ2IEDFZhcmlhYmxlTmFtZZgW
// HA2 QmxlbmRBZGRTcGhlcmUwVGV4dHVyZQEBAQFAHUVmZmVjdERvY3VtZW50LkRpZmZ1c2VFbnRyaWVz
// HA2 QApCbGVuZEVudHJ5BAlJc0VuYWJsZWSYBFRydWUECklzU3BlY3VsYXKYBUZhbHNlBApQYXJhbWV0
// HA2 ZXJYmAtMaWdodE5vcm1hbAQKUGFyYW1ldGVyWZgLTGlnaHROb3JtYWxAEkJsZW5kRW50cnkuQWN0
// HA2 aW9uc3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlw
// HA2 bHkEEFBhcmFtZXRlckNoYW5uZWyYA1JlZAQNVGFyZ2V0Q2hhbm5lbJgDUmVkAUALQmxlbmRBY3Rp
// HA2 b24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmAVHcmVlbgQNVGFyZ2V0Q2hhbm5l
// HA2 bJgFR3JlZW4BQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyY
// HA2 BEJsdWUEDVRhcmdldENoYW5uZWyYBEJsdWUBAQFAEkJsZW5kRW50cnkuVGV4dHVyZUAHVGV4dHVy
// HA2 ZQQETmFtZZgIe3g6TnVsbH0ECEZpbGVOYW1lmBPmi6HmlaPjgrDjg6zjg7wucG5nBARLaW5kmANS
// HA2 Z2IEDFZhcmlhYmxlTmFtZZgUQmxlbmREaWZmdXNlMFRleHR1cmUBAQEBQBpFZmZlY3REb2N1bWVu
// HA2 dC5FZGdlRW50cmllc0AKQmxlbmRFbnRyeQQJSXNFbmFibGVkmAVGYWxzZQQKSXNTcGVjdWxhcpgF
// HA2 RmFsc2UEClBhcmFtZXRlcliYBE5vbmUEClBhcmFtZXRlclmYBE5vbmVAEkJsZW5kRW50cnkuQWN0
// HA2 aW9uc3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtCbGVuZEFjdGlvbgQES2luZJgHUmVwbGFj
// HA2 ZQQQUGFyYW1ldGVyQ2hhbm5lbJgDUmVkBA1UYXJnZXRDaGFubmVsmANSZWQBQAtCbGVuZEFjdGlv
// HA2 bgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBUdyZWVuBA1UYXJnZXRDaGFubmVs
// HA2 mAVHcmVlbgFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgE
// HA2 Qmx1ZQQNVGFyZ2V0Q2hhbm5lbJgEQmx1ZQEBAUASQmxlbmRFbnRyeS5UZXh0dXJlQAdUZXh0dXJl
// HA2 BAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWoBARLaW5kmANSZ2IEDFZhcmlhYmxlTmFtZZgRQmxl
// HA2 bmRFZGdlMFRleHR1cmUBAQEBQB5FZmZlY3REb2N1bWVudC5TcGVjdWxhckVudHJpZXNACkJsZW5k
// HA2 RW50cnkECUlzRW5hYmxlZJgEVHJ1ZQQKSXNTcGVjdWxhcpgEVHJ1ZQQKUGFyYW1ldGVyWJgTRXh0
// HA2 ZW5kZWRMaWdodE5vcm1hbAQKUGFyYW1ldGVyWZgTRXh0ZW5kZWRMaWdodE5vcm1hbEASQmxlbmRF
// HA2 bnRyeS5BY3Rpb25zdQVBcnJheQQEVHlwZZgLQmxlbmRBY3Rpb25AC0JsZW5kQWN0aW9uBARLaW5k
// HA2 mANBZGQEEFBhcmFtZXRlckNoYW5uZWyYA1JlZAQNVGFyZ2V0Q2hhbm5lbJgDUmVkAUALQmxlbmRB
// HA2 Y3Rpb24EBEtpbmSYA0FkZAQQUGFyYW1ldGVyQ2hhbm5lbJgFR3JlZW4EDVRhcmdldENoYW5uZWyY
// HA2 BUdyZWVuAUALQmxlbmRBY3Rpb24EBEtpbmSYA0FkZAQQUGFyYW1ldGVyQ2hhbm5lbJgEQmx1ZQQN
// HA2 VGFyZ2V0Q2hhbm5lbJgEQmx1ZQEBAUASQmxlbmRFbnRyeS5UZXh0dXJlQAdUZXh0dXJlBAROYW1l
// HA2 mAh7eDpOdWxsfQQIRmlsZU5hbWWYE+mPoemdouOCsOODrOODvC5wbmcEBEtpbmSYA1JnYgQMVmFy
// HA2 aWFibGVOYW1lmBVCbGVuZFNwZWN1bGFyMFRleHR1cmUBAQEBAQ==