#include "HAHead.hlsl"

//#define BLENDDIFFUSE0TEXTURE "BannyB.png"
#define BLENDDIFFUSE0TEXTURE_X 256
#define BLENDDIFFUSE0TEXTURE_Y 256
#define BLENDDIFFUSE1TEXTURE "BannyA.png"
#define BLENDDIFFUSE1TEXTURE_X 256
#define BLENDDIFFUSE1TEXTURE_Y 256
//#define BLENDSPECULAR0TEXTURE "_.png"
#define BLENDSPECULAR0TEXTURE_X 256
#define BLENDSPECULAR0TEXTURE_Y 256
#define BLENDEDGE0TEXTURE
#define BLENDEDGE0TEXTURE_X 256
#define BLENDEDGE0TEXTURE_Y 256
//#define USE_LOCALSHADOW
#define USE_EXCELLENTSHADOW
#define SHADE_TOONLESS
//#define AMBIENT_AS_BASE
//#define AMBIENT_TOON_AS_BASE
//#define HANDLE_EDGE
//#define USE_NORMALMAP
#ifdef BLENDDIFFUSE0TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendDiffuse0Texture, BlendDiffuse0TextureSampler, BLENDDIFFUSE0TEXTURE, Clamp, Clamp)
#endif
#ifdef BLENDDIFFUSE1TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendDiffuse1Texture, BlendDiffuse1TextureSampler, BLENDDIFFUSE1TEXTURE, Clamp, Clamp)
#endif
#ifdef BLENDSPECULAR0TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendSpecular0Texture, BlendSpecular0TextureSampler, BLENDSPECULAR0TEXTURE, Clamp, Clamp)
#endif

float EdgeWidthRate
<
	string UIName = "GbW";
	string UIWidget = "Numeric";
	float UIMin = 0;
	float UIMax = 2;
> = 0.8;

float NormalMapResolution
<
string UIName = "@}bv𑜓x";
string UIWidget = "Numeric";
float UIMin = 0;
float UIMax = 10;
> = 1;

float3 BlendDiffuse0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE0TEXTURE
	float4 value = tex2D(BlendDiffuse0TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse1(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE1TEXTURE
	float4 value = tex2D(BlendDiffuse1TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse(float3 color, BlendParameters parameters)
{
	color = BlendDiffuse0(color, parameters);
	color = BlendDiffuse1(color, parameters);

	return color;
}

float3 BlendSpecular0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDSPECULAR0TEXTURE
	float4 value = tex2D(BlendSpecular0TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r += value.r * value.a;
	target.g += value.g * value.a;
	target.b += value.b * value.a;
	#endif
	
	return target;
}

float3 BlendSpecular(float3 color, BlendParameters parameters)
{
	color = BlendSpecular0(color, parameters);

	return color;
}



float3 BlendAddSphere(float3 color, BlendParameters parameters)
{


	return color;
}

float3 BlendEdge0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDEDGE0TEXTURE
	float4 value = float4(0, 0, 0, 1);
	
	target.r = lerp(target.r, value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendEdge(float3 color, BlendParameters parameters)
{
	color = BlendEdge0(color, parameters);

	return color;
}

#include "HACore.hlsl"

// HAGenerator Document
// HA2 QA5FZmZlY3REb2N1bWVudAQVQ29weUNvcmVUb0Rlc3RpbmF0aW9umARUcnVlBAlFZGdlV2lkdGiY
// HA2 AzAuOAQRRml4TGlnaHREaXJlY3Rpb26YBUZhbHNlBAxGaXhTcGhlcmVNYXCYBUZhbHNlBApIYW5k
// HA2 bGVFZGdlmAVGYWxzZQQTTm9ybWFsTWFwUmVzb2x1dGlvboIEEE5vcm1hbE1hcFRleHR1cmWoBBBT
// HA2 ZXRBbWJpZW50QXNCYXNlmAVGYWxzZQQYU2V0QW1iaWVudEFzQmFzZVdpdGhUb29umAVGYWxzZQQN
// HA2 U2hhZGVUb29ubGVzc5gEVHJ1ZQQSVXNlRXhjZWxsZW50U2hhZG93mARUcnVlBA5Vc2VMb2NhbFNo
// HA2 YWRvd5gFRmFsc2UEDFVzZU5vcm1hbE1hcJgFRmFsc2UIOWNsci1uYW1lc3BhY2U6TGluZWFyc3Rh
// HA2 ci5IQUdlbmVyYXRvcjthc3NlbWJseT1IQUdlbmVyYXRvcgkBeCxodHRwOi8vc2NoZW1hcy5taWNy
// HA2 b3NvZnQuY29tL3dpbmZ4LzIwMDYveGFtbEAdRWZmZWN0RG9jdW1lbnQuRGlmZnVzZUVudHJpZXNA
// HA2 CkJsZW5kRW50cnkECUlzRW5hYmxlZJgFRmFsc2UECklzU3BlY3VsYXKYBUZhbHNlBApQYXJhbWV0
// HA2 ZXJYmBNFeHRlbmRlZExpZ2h0Tm9ybWFsBApQYXJhbWV0ZXJZmBNFeHRlbmRlZExpZ2h0Tm9ybWFs
// HA2 QBJCbGVuZEVudHJ5LkFjdGlvbnN1BUFycmF5BARUeXBlmAtCbGVuZEFjdGlvbkALQmxlbmRBY3Rp
// HA2 b24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmANSZWQEDVRhcmdldENoYW5uZWyY
// HA2 A1JlZAFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgFR3Jl
// HA2 ZW4EDVRhcmdldENoYW5uZWyYBUdyZWVuAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQ
// HA2 YXJhbWV0ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVsmARCbHVlAQEBQBJCbGVuZEVudHJ5
// HA2 LlRleHR1cmVAB1RleHR1cmUEBE5hbWWYCHt4Ok51bGx9BAhGaWxlTmFtZZgNQmFubnnogoxCLnBu
// HA2 ZwQES2luZJgDUmdiBAxWYXJpYWJsZU5hbWWYFEJsZW5kRGlmZnVzZTBUZXh0dXJlAQEBQApCbGVu
// HA2 ZEVudHJ5BAlJc0VuYWJsZWSYBFRydWUECklzU3BlY3VsYXKYBUZhbHNlBApQYXJhbWV0ZXJYmBNF
// HA2 eHRlbmRlZExpZ2h0Tm9ybWFsBApQYXJhbWV0ZXJZmBNFeHRlbmRlZExpZ2h0Tm9ybWFsQBJCbGVu
// HA2 ZEVudHJ5LkFjdGlvbnN1BUFycmF5BARUeXBlmAtCbGVuZEFjdGlvbkALQmxlbmRBY3Rpb24EBEtp
// HA2 bmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmANSZWQEDVRhcmdldENoYW5uZWyYA1JlZAFA
// HA2 C0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgFR3JlZW4EDVRh
// HA2 cmdldENoYW5uZWyYBUdyZWVuAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0
// HA2 ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVsmARCbHVlAQEBQBJCbGVuZEVudHJ5LlRleHR1
// HA2 cmVAB1RleHR1cmUEBE5hbWWYCHt4Ok51bGx9BAhGaWxlTmFtZZgNQmFubnnogoxBLnBuZwQES2lu
// HA2 ZJgDUmdiBAxWYXJpYWJsZU5hbWWYFEJsZW5kRGlmZnVzZTFUZXh0dXJlAQEBAUAaRWZmZWN0RG9j
// HA2 dW1lbnQuRWRnZUVudHJpZXNACkJsZW5kRW50cnkECUlzRW5hYmxlZJgEVHJ1ZQQKSXNTcGVjdWxh
// HA2 cpgFRmFsc2UEClBhcmFtZXRlcliYBE5vbmUEClBhcmFtZXRlclmYBE5vbmVAEkJsZW5kRW50cnku
// HA2 QWN0aW9uc3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtCbGVuZEFjdGlvbgQES2luZJgHUmVw
// HA2 bGFjZQQQUGFyYW1ldGVyQ2hhbm5lbJgDUmVkBA1UYXJnZXRDaGFubmVsmANSZWQBQAtCbGVuZEFj
// HA2 dGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBUdyZWVuBA1UYXJnZXRDaGFu
// HA2 bmVsmAVHcmVlbgFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5l
// HA2 bJgEQmx1ZQQNVGFyZ2V0Q2hhbm5lbJgEQmx1ZQEBAUASQmxlbmRFbnRyeS5UZXh0dXJlQAdUZXh0
// HA2 dXJlBAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWoBARLaW5kmANSZ2IEDFZhcmlhYmxlTmFtZZgR
// HA2 QmxlbmRFZGdlMFRleHR1cmUBAQEBQB5FZmZlY3REb2N1bWVudC5TcGVjdWxhckVudHJpZXNACkJs
// HA2 ZW5kRW50cnkECUlzRW5hYmxlZJgFRmFsc2UECklzU3BlY3VsYXKYBFRydWUEClBhcmFtZXRlcliY
// HA2 E0V4dGVuZGVkTGlnaHROb3JtYWwEClBhcmFtZXRlclmYE0V4dGVuZGVkTGlnaHROb3JtYWxAEkJs
// HA2 ZW5kRW50cnkuQWN0aW9uc3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtCbGVuZEFjdGlvbgQE
// HA2 S2luZJgDQWRkBBBQYXJhbWV0ZXJDaGFubmVsmANSZWQEDVRhcmdldENoYW5uZWyYA1JlZAFAC0Js
// HA2 ZW5kQWN0aW9uBARLaW5kmANBZGQEEFBhcmFtZXRlckNoYW5uZWyYBUdyZWVuBA1UYXJnZXRDaGFu
// HA2 bmVsmAVHcmVlbgFAC0JsZW5kQWN0aW9uBARLaW5kmANBZGQEEFBhcmFtZXRlckNoYW5uZWyYBEJs
// HA2 dWUEDVRhcmdldENoYW5uZWyYBEJsdWUBAQFAEkJsZW5kRW50cnkuVGV4dHVyZUAHVGV4dHVyZQQE
// HA2 TmFtZZgIe3g6TnVsbH0ECEZpbGVOYW1lmA7pj6HpnaJf6IKMLnBuZwQES2luZJgDUmdiBAxWYXJp
// HA2 YWJsZU5hbWWYFUJsZW5kU3BlY3VsYXIwVGV4dHVyZQEBAQEB